#ifndef ELEMENTS_PROPAGATION_HH
#define ELEMENTS_PROPAGATION_HH
#include "truncPolySystem.hh"
#include "Print.hh"

namespace poly {

template<typename scalar, int numVarsIn, int numVarsOut>
static inline void propagate(truncPolySystem<scalar, numVarsIn, numVarsOut> &poly, float l)
{
  poly.clear();
  if(numVarsOut > 4)
    poly[4].unity(4);

  // How does x' depend?
  poly[0].add(Term5f(1.0f, 1,0,0,0,0));
  poly[0].add(Term5f(l,    0,0,1,0,0));

  // How does y' depend?
  poly[1].add(Term5f(1.0f, 0,1,0,0,0));
  poly[1].add(Term5f(l,    0,0,0,1,0));

  // How does dx' depend?
  poly[2].add(Term5f(1.0f, 0,0,1,0,0)); // dx remains unchanged

  // How does dy' depend?
  poly[3].add(Term5f(1.0f, 0,0,0,1,0)); // dy remains unchanged
}

} // namespace poly

#endif
