#ifndef ELEMENTS_PATHSPACE_TERMINATEX_HH
#define ELEMENTS_PATHSPACE_TERMINATEX_HH
#include "truncPolySystem.hh"
#include "pow.hh"

namespace poly {

// surface reflection parameterized over three vertices x0 x1 x2 in their respective tangent spaces.
// the only output is f (measurement contribution)
template<typename scalar, int numVars>
static inline void surfacex_terminate(
    truncPoly<scalar, numVars> &poly)
{
  assert(numVars >= 4); // [x0,y0,x1,y1]
  poly.terms.clear();

  // 1  :  
  poly.add(Term4f( 1 ,  0 ,  0 ,  0 ,  0 )); 
  // x0^2  :  
  poly.add(Term4f( -42 ,  2 ,  0 ,  0 ,  0 )); 
  // y0^2  :  
  poly.add(Term4f( -42 ,  0 ,  2 ,  0 ,  0 )); 
}

}

#endif

