
#ifndef POLY_CONVENIENCE_HH
#define POLY_CONVENIENCE_HH

#include "truncPolySystem.hh"

namespace poly {


// Abbreviated class names

typedef polyTerm<float,1> Term1f;
typedef polyTerm<float,2> Term2f;
typedef polyTerm<float,3> Term3f;
typedef polyTerm<float,4> Term4f;
typedef polyTerm<float,5> Term5f;
typedef polyTerm<float,6> Term6f;
typedef polyTerm<float,7> Term7f;
typedef polyTerm<double,1> Term1d;
typedef polyTerm<double,2> Term2d;
typedef polyTerm<double,3> Term3d;
typedef polyTerm<double,4> Term4d;
typedef polyTerm<double,5> Term5d;
typedef polyTerm<double,6> Term6d;
typedef polyTerm<double,7> Term7d;
typedef polyTerm<long double,1> Term1l;
typedef polyTerm<long double,2> Term2l;
typedef polyTerm<long double,3> Term3l;
typedef polyTerm<long double,4> Term4l;
typedef polyTerm<long double,5> Term5l;
typedef polyTerm<long double,6> Term6l;
typedef polyTerm<long double,7> Term7l;


typedef truncPoly<float,1> Poly1f;
typedef truncPoly<float,2> Poly2f;
typedef truncPoly<float,3> Poly3f;
typedef truncPoly<float,4> Poly4f;
typedef truncPoly<float,5> Poly5f;
typedef truncPoly<float,6> Poly6f;
typedef truncPoly<float,7> Poly7f;
typedef truncPoly<double,1> Poly1d;
typedef truncPoly<double,2> Poly2d;
typedef truncPoly<double,3> Poly3d;
typedef truncPoly<double,4> Poly4d;
typedef truncPoly<double,5> Poly5d;
typedef truncPoly<double,6> Poly6d;
typedef truncPoly<double,7> Poly7d;
typedef truncPoly<long double,1> Poly1l;
typedef truncPoly<long double,2> Poly2l;
typedef truncPoly<long double,3> Poly3l;
typedef truncPoly<long double,4> Poly4l;
typedef truncPoly<long double,5> Poly5l;
typedef truncPoly<long double,6> Poly6l;
typedef truncPoly<long double,7> Poly7l;



// Transforms: square version of system

typedef truncPolySystem<float,1,1> PolyT1f;
typedef truncPolySystem<float,2,2> PolyT2f;
typedef truncPolySystem<float,3,3> PolyT3f;
typedef truncPolySystem<float,4,4> PolyT4f;
typedef truncPolySystem<float,5,5> PolyT5f;
typedef truncPolySystem<float,6,6> PolyT6f;
typedef truncPolySystem<float,7,7> PolyT7f;
typedef truncPolySystem<double,1,1> PolyT1d;
typedef truncPolySystem<double,2,2> PolyT2d;
typedef truncPolySystem<double,3,3> PolyT3d;
typedef truncPolySystem<double,4,4> PolyT4d;
typedef truncPolySystem<double,5,5> PolyT5d;
typedef truncPolySystem<double,6,6> PolyT6d;
typedef truncPolySystem<double,7,7> PolyT7d;
typedef truncPolySystem<long double,1,1> PolyT1l;
typedef truncPolySystem<long double,2,2> PolyT2l;
typedef truncPolySystem<long double,3,3> PolyT3l;
typedef truncPolySystem<long double,4,4> PolyT4l;
typedef truncPolySystem<long double,5,5> PolyT5l;
typedef truncPolySystem<long double,6,6> PolyT6l;
typedef truncPolySystem<long double,7,7> PolyT7l;

} // namespace poly

#endif
