#include "lensflare.h"

#include <stdio.h>
#include <stdlib.h>

int main(int argc, char *argv[])
{
    lensflare_t *flare = lf_lensflare_init(1);

    int width = 512, height = 512, num_samples = 64;
    float *buffer = 0;
    if(posix_memalign((void **)&buffer, 1024, width*height*3*sizeof(float)))
    {
        fprintf(stderr, "[lensflare_test] failed to allocate buffer.\n");
        exit(1);
    }

    // see lenses/ for more input data:
    // int num_flares = lf_lensflare_setup(flare, "lenses/Canon-MassiveAnamorphicZoom.txt");
    // int num_flares = lf_lensflare_setup(flare, "lenses/lensbaby.fx");
    lf_lensflare_setup(flare, "lenses/ItohZoom.fx");
    // -1 means all possible flares (two-bounce *R*R* type paths only)
    // second argument is smoothing on (!=0) or off (0)
    lf_lensflare_compile(flare, -1, 1);//num_flares/2, 0);
    const float rgb[3] = {1., 1., 1.};
    const float sun[3] = {100., 0., 1000.};
    lf_lensflare_set_sun(flare, sun, rgb);
    lf_lensflare_render(flare, buffer, width, height, num_samples);
    lf_lensflare_cleanup(flare);

    // write out what we've got:
    FILE *f = fopen("dreggn.pfm", "wb");
    fprintf(f, "PF\n%d %d\n-1.0\n", width, height);
    fwrite(buffer, width*height*3, sizeof(float), f);
    fclose(f);

    free(buffer);
    exit(0);
}
