#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <string.h>

int main(int argc, char *argv[])
{
    int width = 1024, height = 1024;
    const int tile = 128;
    float *buf = (float *)malloc(sizeof(float)*3*width*height);
    for(int j=0;j<height;j++)
    {
        for(int i=0;i<width;i++)
        {
            // grid:
            if(((i%tile < tile/16 || i%tile > tile - tile/16) && (i&1)) ||
               ((j%tile < tile/16 || j%tile > tile - tile/16) && (j&1)))
                for(int c=0;c<3;c++) buf[3*(width*j + i) + c] = 1.0f;
            else
                for(int c=0;c<3;c++) buf[3*(width*j + i) + c] = 0.0f;
            // points in center:
            if((labs(i%tile - tile/2) < 2) &&
               (labs(j%tile - tile/2) < 2))
            {
                // first dot is a supernova (=>lensflare)
                if(i/tile == 0 && j/tile == 0)
                    for(int c=0;c<3;c++) buf[3*(width*j + i) + c] = 100000.0f;
                else
                    for(int c=0;c<3;c++) buf[3*(width*j + i) + c] = 1.0f;
            }
        }
    }
    FILE *f = fopen("test.pfm", "wb");
    fprintf(f, "PF\n%d %d\n-1.0\n", width, height);
    fwrite(buf, 3*sizeof(float), width*height, f);
    fclose(f);
    free(buf);

#if 0
    width = 1536;
    height = 1024;
    buf = (float *)malloc(sizeof(float)*3*width*height);
    memset(buf,0,3*sizeof(float));
    for(int j=0;j<height;j++)
    {
        for(int i=0;i<width;i++)
        {
            // grid:
            if(((i%tile < tile/32 || i%tile > tile - tile/32) && (i&1)) ||
               ((j%tile < tile/32 || j%tile > tile - tile/32) && (j&1)))
                for(int c=0;c<3;c++) buf[3*(width*j + i) + c] = 1.0f;
            else
                for(int c=0;c<3;c++) buf[3*(width*j + i) + c] = 0.0f;
            // points in center:
            if((labs(i%tile - tile/2) < 1) &&
               (labs(j%tile - tile/2) < 1))
            {
                    for(int c=0;c<3;c++) buf[3*(width*j + i) + c] = 1000.0f;
            }
        }
    }

    for (float angle = 0; angle < 3.1415926 * 2; angle += 0.0001) {
      int i = width / 2 + 0.375 * height * sin(angle) + (rand()/(float)RAND_MAX - 0.5);
      int j = height / 2 + 0.375 * height * cos(angle) + (rand()/(float)RAND_MAX - 0.5);
      for(int c=0;c<3;c++) buf[3*(width*j + i) + c] += .1f;
      i = width / 2 + 0.25 * height * sin(angle) + (rand()/(float)RAND_MAX - 0.5);
      j = height / 2 + 0.25 * height * cos(angle) + (rand()/(float)RAND_MAX - 0.5);
      for(int c=0;c<3;c++) buf[3*(width*j + i) + c] += 0.05f;
     
      i = width / 2 + 0.125 * height * sin(angle) + (rand()/(float)RAND_MAX - 0.5);
      j = height / 2 + 0.125 * height * cos(angle) + (rand()/(float)RAND_MAX - 0.5);
      for(int c=0;c<3;c++) buf[3*(width*j + i) + c] += 0.03333333f;
      i = width / 2 + 0.5 * height * sin(angle) + (rand()/(float)RAND_MAX - 0.5);
      j = height / 2 + 0.5 * height * cos(angle) + (rand()/(float)RAND_MAX - 0.5);
      if (j >= 0 && j < height)
      for(int c=0;c<3;c++) buf[3*(width*j + i) + c] += .13333333f;
      i = width / 2 + 0.625 * height * sin(angle) + (rand()/(float)RAND_MAX - 0.5);
      j = height / 2 + 0.625 * height * cos(angle) + (rand()/(float)RAND_MAX - 0.5);
      if (j >= 0 && j < height)
      for(int c=0;c<3;c++) buf[3*(width*j + i) + c] +=.16666666f;
     }
    f = fopen("testgridcirc.pfm", "wb");
    fprintf(f, "PF\n%d %d\n-1.0\n", width, height);
    fwrite(buf, 3*sizeof(float), width*height, f);
    fclose(f);
    free(buf);
#endif
    exit(0);
}

